<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Common Utilities</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__commonutil.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Common Utilities</div>  </div>
</div><!--header-->
<div class="contents">

<p>These are free functions and utility classes in the Common library.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileRemover.html">OpenSim::FileRemover</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">When an instance of this class is destructed, it removes (deletes) the file at the path provided in the constructor.  <a href="classOpenSim_1_1FileRemover.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ThreadsafeJar.html">OpenSim::ThreadsafeJar&lt; T &gt;</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class lets you store objects of a single type for reuse by multiple threads, ensuring threadsafe access to each of those objects.  <a href="classOpenSim_1_1ThreadsafeJar.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gaa258d8737b024554c06553d1d88266c0"><td class="memTemplParams" colspan="2">template&lt;typename T , typename... Args&gt; </td></tr>
<tr class="memitem:gaa258d8737b024554c06553d1d88266c0"><td class="memTemplItemLeft" align="right" valign="top">std::unique_ptr&lt; T &gt;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0">OpenSim::make_unique</a> (Args &amp;&amp;... args)</td></tr>
<tr class="memdesc:gaa258d8737b024554c06553d1d88266c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Since <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> does not require C++14 (which contains <a class="el" href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0" title="Since OpenSim does not require C++14 (which contains std::make_unique()), here is an implementation o...">std::make_unique()</a>), here is an implementation of <a class="el" href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0" title="Since OpenSim does not require C++14 (which contains std::make_unique()), here is an implementation o...">make_unique()</a>.  <a href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0">More...</a><br /></td></tr>
<tr class="separator:gaa258d8737b024554c06553d1d88266c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaee5c8bd6f089ca1cdebdb5d47606caf7"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#gaee5c8bd6f089ca1cdebdb5d47606caf7">OpenSim::getFormattedDateTime</a> (bool appendMicroseconds=false, std::string format=&quot;%Y-%m-%dT%H%M%S&quot;)</td></tr>
<tr class="memdesc:gaee5c8bd6f089ca1cdebdb5d47606caf7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a string with the current date and time formatted as Y-m-dTHMS (year, month, day, "T", hour, minute, second).  <a href="group__commonutil.html#gaee5c8bd6f089ca1cdebdb5d47606caf7">More...</a><br /></td></tr>
<tr class="separator:gaee5c8bd6f089ca1cdebdb5d47606caf7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga25ead5023c31599b8689b5a7a2fabe47"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API SimTK::Vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#ga25ead5023c31599b8689b5a7a2fabe47">OpenSim::createVectorLinspace</a> (int length, double start, double end)</td></tr>
<tr class="memdesc:ga25ead5023c31599b8689b5a7a2fabe47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a SimTK::Vector with the provided length whose elements are uniformly spaced between start and end (same as Matlab's linspace()).  <a href="group__commonutil.html#ga25ead5023c31599b8689b5a7a2fabe47">More...</a><br /></td></tr>
<tr class="separator:ga25ead5023c31599b8689b5a7a2fabe47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6bf16005aeba9f80fd3caac53abdc2b8"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API SimTK::Vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#ga6bf16005aeba9f80fd3caac53abdc2b8">OpenSim::createVector</a> (std::initializer_list&lt; SimTK::Real &gt; elements)</td></tr>
<tr class="memdesc:ga6bf16005aeba9f80fd3caac53abdc2b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a SimTK::Vector using modern C++ syntax.  <a href="group__commonutil.html#ga6bf16005aeba9f80fd3caac53abdc2b8">More...</a><br /></td></tr>
<tr class="separator:ga6bf16005aeba9f80fd3caac53abdc2b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab838826f9af13dc9371cf0a2e5ee81ed"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API SimTK::Vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#gab838826f9af13dc9371cf0a2e5ee81ed">OpenSim::interpolate</a> (const SimTK::Vector &amp;x, const SimTK::Vector &amp;y, const SimTK::Vector &amp;newX, const bool ignoreNaNs=false)</td></tr>
<tr class="memdesc:gab838826f9af13dc9371cf0a2e5ee81ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Linearly interpolate y(x) at new values of x.  <a href="group__commonutil.html#gab838826f9af13dc9371cf0a2e5ee81ed">More...</a><br /></td></tr>
<tr class="separator:gab838826f9af13dc9371cf0a2e5ee81ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9272efda6a4bcff076e65269740a6f62"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#ga9272efda6a4bcff076e65269740a6f62">OpenSim::convertRelativeFilePathToAbsoluteFromXMLDocument</a> (const std::string &amp;documentFileName, const std::string &amp;filePathRelativeToDirectoryContainingDocument)</td></tr>
<tr class="memdesc:ga9272efda6a4bcff076e65269740a6f62"><td class="mdescLeft">&#160;</td><td class="mdescRight">An <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> XML file may contain file paths that are relative to the directory containing the XML file; use this function to convert that relative path into an absolute path.  <a href="group__commonutil.html#ga9272efda6a4bcff076e65269740a6f62">More...</a><br /></td></tr>
<tr class="separator:ga9272efda6a4bcff076e65269740a6f62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2a5317a7c4397393304d984422acbc65"><td class="memItemLeft" align="right" valign="top">OSIMCOMMON_API SimTK::Real&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__commonutil.html#ga2a5317a7c4397393304d984422acbc65">OpenSim::solveBisection</a> (std::function&lt; double(const double &amp;)&gt; calcResidual, double left, double right, const double &amp;tolerance=1e-6, int maxIterations=1000)</td></tr>
<tr class="memdesc:ga2a5317a7c4397393304d984422acbc65"><td class="mdescLeft">&#160;</td><td class="mdescRight">Solve for the root of a scalar function using the bisection method.  <a href="group__commonutil.html#ga2a5317a7c4397393304d984422acbc65">More...</a><br /></td></tr>
<tr class="separator:ga2a5317a7c4397393304d984422acbc65"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>These are free functions and utility classes in the Common library. </p>
<h2 class="groupheader">Function Documentation</h2>
<a id="ga9272efda6a4bcff076e65269740a6f62"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga9272efda6a4bcff076e65269740a6f62">&#9670;&nbsp;</a></span>convertRelativeFilePathToAbsoluteFromXMLDocument()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API std::string OpenSim::convertRelativeFilePathToAbsoluteFromXMLDocument </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>documentFileName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filePathRelativeToDirectoryContainingDocument</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>An <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> XML file may contain file paths that are relative to the directory containing the XML file; use this function to convert that relative path into an absolute path. </p>

</div>
</div>
<a id="ga6bf16005aeba9f80fd3caac53abdc2b8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga6bf16005aeba9f80fd3caac53abdc2b8">&#9670;&nbsp;</a></span>createVector()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API SimTK::Vector OpenSim::createVector </td>
          <td>(</td>
          <td class="paramtype">std::initializer_list&lt; SimTK::Real &gt;&#160;</td>
          <td class="paramname"><em>elements</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a SimTK::Vector using modern C++ syntax. </p>

</div>
</div>
<a id="ga25ead5023c31599b8689b5a7a2fabe47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga25ead5023c31599b8689b5a7a2fabe47">&#9670;&nbsp;</a></span>createVectorLinspace()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API SimTK::Vector OpenSim::createVectorLinspace </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>end</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a SimTK::Vector with the provided length whose elements are uniformly spaced between start and end (same as Matlab's linspace()). </p>

</div>
</div>
<a id="gaee5c8bd6f089ca1cdebdb5d47606caf7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaee5c8bd6f089ca1cdebdb5d47606caf7">&#9670;&nbsp;</a></span>getFormattedDateTime()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API std::string OpenSim::getFormattedDateTime </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>appendMicroseconds</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>format</em> = <code>&quot;%Y-%m-%dT%H%M%S&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get a string with the current date and time formatted as Y-m-dTHMS (year, month, day, "T", hour, minute, second). </p>
<p>You can change the datetime format via the <code>format</code> parameter. If you specify "ISO", then we use the ISO 8601 extended datetime format Y-m-dTH:M:S. See <a href="https://en.cppreference.com/w/cpp/io/manip/put_time">https://en.cppreference.com/w/cpp/io/manip/put_time</a>. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="gab838826f9af13dc9371cf0a2e5ee81ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gab838826f9af13dc9371cf0a2e5ee81ed">&#9670;&nbsp;</a></span>interpolate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API SimTK::Vector OpenSim::interpolate </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>newX</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const bool&#160;</td>
          <td class="paramname"><em>ignoreNaNs</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Linearly interpolate y(x) at new values of x. </p>
<p>The optional 'ignoreNaNs' argument will ignore any NaN values contained in the input vectors and create the interpolant from the non-NaN values only. Note that this option does not necessarily prevent NaN values from being returned in 'newX', which will have NaN for any values of newX outside of the range of x. </p><dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if x and y are different sizes, or x or y is empty. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gaa258d8737b024554c06553d1d88266c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa258d8737b024554c06553d1d88266c0">&#9670;&nbsp;</a></span>make_unique()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename... Args&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt;T&gt; OpenSim::make_unique </td>
          <td>(</td>
          <td class="paramtype">Args &amp;&amp;...&#160;</td>
          <td class="paramname"><em>args</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Since <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> does not require C++14 (which contains <a class="el" href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0" title="Since OpenSim does not require C++14 (which contains std::make_unique()), here is an implementation o...">std::make_unique()</a>), here is an implementation of <a class="el" href="group__commonutil.html#gaa258d8737b024554c06553d1d88266c0" title="Since OpenSim does not require C++14 (which contains std::make_unique()), here is an implementation o...">make_unique()</a>. </p>

</div>
</div>
<a id="ga2a5317a7c4397393304d984422acbc65"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga2a5317a7c4397393304d984422acbc65">&#9670;&nbsp;</a></span>solveBisection()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMCOMMON_API SimTK::Real OpenSim::solveBisection </td>
          <td>(</td>
          <td class="paramtype">std::function&lt; double(const double &amp;)&gt;&#160;</td>
          <td class="paramname"><em>calcResidual</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>left</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>right</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double &amp;&#160;</td>
          <td class="paramname"><em>tolerance</em> = <code>1e-6</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>maxIterations</em> = <code>1000</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Solve for the root of a scalar function using the bisection method. </p>
<p>If the values of calcResidual(left) and calcResidual(right) have the same sign and the logger level is Debug (or more verbose), then this function writes a file <code>solveBisection_residual_&lt;timestamp&gt;.sto</code> containing the residual function. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">calcResidual</td><td>a function that computes the error </td></tr>
    <tr><td class="paramname">left</td><td>lower bound on the root </td></tr>
    <tr><td class="paramname">right</td><td>upper bound on the root </td></tr>
    <tr><td class="paramname">tolerance</td><td>convergence requires that the bisection's "left" and "right" are less than tolerance apart. </td></tr>
    <tr><td class="paramname">maxIterations</td><td>abort after this many iterations. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:40 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
